// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package task

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/workflow/workflow_models"
)

// GetTasksReader is a Reader for the GetTasks structure.
type GetTasksReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTasksReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTasksOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTasksUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTasksForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTasksNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTasksUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTasksInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetTasksOK creates a GetTasksOK with default headers values
func NewGetTasksOK() *GetTasksOK {
	return &GetTasksOK{}
}

/* GetTasksOK describes a response with status code 200, with default header values.

Array of Tasks
*/
type GetTasksOK struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.TaskResponse
}

func (o *GetTasksOK) Error() string {
	return fmt.Sprintf("[GET /tasks][%d] getTasksOK  %+v", 200, o.Payload)
}
func (o *GetTasksOK) GetPayload() *workflow_models.TaskResponse {
	return o.Payload
}

func (o *GetTasksOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.TaskResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTasksUnauthorized creates a GetTasksUnauthorized with default headers values
func NewGetTasksUnauthorized() *GetTasksUnauthorized {
	return &GetTasksUnauthorized{}
}

/* GetTasksUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTasksUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *GetTasksUnauthorized) Error() string {
	return fmt.Sprintf("[GET /tasks][%d] getTasksUnauthorized  %+v", 401, o.Payload)
}
func (o *GetTasksUnauthorized) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *GetTasksUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTasksForbidden creates a GetTasksForbidden with default headers values
func NewGetTasksForbidden() *GetTasksForbidden {
	return &GetTasksForbidden{}
}

/* GetTasksForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetTasksForbidden struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *GetTasksForbidden) Error() string {
	return fmt.Sprintf("[GET /tasks][%d] getTasksForbidden  %+v", 403, o.Payload)
}
func (o *GetTasksForbidden) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *GetTasksForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTasksNotFound creates a GetTasksNotFound with default headers values
func NewGetTasksNotFound() *GetTasksNotFound {
	return &GetTasksNotFound{}
}

/* GetTasksNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetTasksNotFound struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *GetTasksNotFound) Error() string {
	return fmt.Sprintf("[GET /tasks][%d] getTasksNotFound  %+v", 404, o.Payload)
}
func (o *GetTasksNotFound) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *GetTasksNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTasksUnprocessableEntity creates a GetTasksUnprocessableEntity with default headers values
func NewGetTasksUnprocessableEntity() *GetTasksUnprocessableEntity {
	return &GetTasksUnprocessableEntity{}
}

/* GetTasksUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTasksUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *GetTasksUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /tasks][%d] getTasksUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetTasksUnprocessableEntity) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *GetTasksUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTasksInternalServerError creates a GetTasksInternalServerError with default headers values
func NewGetTasksInternalServerError() *GetTasksInternalServerError {
	return &GetTasksInternalServerError{}
}

/* GetTasksInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetTasksInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *workflow_models.Error
}

func (o *GetTasksInternalServerError) Error() string {
	return fmt.Sprintf("[GET /tasks][%d] getTasksInternalServerError  %+v", 500, o.Payload)
}
func (o *GetTasksInternalServerError) GetPayload() *workflow_models.Error {
	return o.Payload
}

func (o *GetTasksInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(workflow_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
